#include <stdio.h>
#include <stdlib.h> 
#include <string.h>
#include "SDL.h"
#include "SDL_image.h"

SDL_Surface* LoadFont(char* BitmapFont);
void DrawText(SDL_Surface* sFont, int x, int y, char * str);

SDL_Surface* screen;

/* ------------------------------------------- */
int main(int argc, char *argv[]){ 
 
 if ( SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO) < 0 ){ 
   printf("Unable to init SDL: %s\n", SDL_GetError()); 
   exit(1); 
 } 
 
 atexit(SDL_Quit); 

 SDL_WM_SetCaption("SDL Gfx Example #1","ex1");
 SDL_WM_SetIcon(SDL_LoadBMP("icon.bmp"), NULL);
 
 screen=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_DOUBLEBUF); 
 if ( screen == NULL ){ 
   printf("Unable to set 640x480 video: %s\n", SDL_GetError()); 
   exit(1); 
 } 
 
 SDL_Surface* sFont;
 sFont = LoadFont("font.png");
 DrawText(sFont, 20, 150, "BITMAP FONT EXAMPLE");
 

 
 int done=0; 
 while(done == 0){ 
   
   SDL_Event event; 
   
   while ( SDL_PollEvent(&event) ){ 
     if ( event.type == SDL_QUIT ){ 
      done = 1; 
     } 
     if ( event.type == SDL_KEYDOWN ){
       if ( event.key.keysym.sym == SDLK_ESCAPE ){ 
         done = 1; 
       } 
     } 
   } 
  
 }
  
}

/* ------------------------------------------------------ */
SDL_Surface* LoadFont(char* BitmapFont){

  SDL_Surface* temp;
  
  temp = IMG_Load(BitmapFont);
  if(temp == NULL){
  	printf("Can't load image %s\n",BitmapFont);
	return NULL;
  }
  
  SDL_SetColorKey(temp,SDL_SRCCOLORKEY,SDL_MapRGB(temp->format,255,255,255));
  
  return temp;

}

/* ------------------------------------------------------ */
void DrawText(SDL_Surface* sFont, int x, int y, char * str){

  int i;
  SDL_Rect src, dest;
  
  for (i = 0; i < strlen(str); i++)
    {
      if (str[i] >= 'A' && str[i] <= 'Z')
	{
	  src.x = (str[i] - 'A') * 32;
	  src.y = 0;
	  src.w = 32;
	  src.h = 32;
	  
	  dest.x = x + (i * 32);
	  dest.y = y;
	  dest.w = 32;
	  dest.h = 32;
	  
	  SDL_BlitSurface(sFont, &src,
			  screen, &dest);
	}
    }
  SDL_Flip(screen);
  
}
