#include <stdio.h>
#include <stdlib.h>

#include "csprite.h"
#include "cspritebase.h"

#include "SDL.h"


SDL_Surface* ImageLoad(char *file);
int InitImages();
void DrawIMG(SDL_Surface *img, int x, int y);
void DrawBG(void);
void DrawScene(void);

SDL_Surface *screen, *back;
CSpriteBase svenbase;
CSpriteBase sheepbase;
CSprite sven;
CSprite sheep;
CSprite sheep1;


//-----------------------------------------
int main(int argc, char *argv[]){ 
 
 Uint8* keys;
 
 if ( SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO) < 0 ){ 
   printf("Unable to init SDL: %s\n", SDL_GetError()); 
   exit(1); 
 } 
 
 atexit(SDL_Quit); 

 SDL_WM_SetCaption("SDL Gfx Example #3","ex3");
 SDL_WM_SetIcon(SDL_LoadBMP("icon.bmp"), NULL);
 
 screen=SDL_SetVideoMode(800,600,32,SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_FULLSCREEN); //
 if ( screen == NULL ){ 
   printf("Unable to set 800x600 video: %s\n", SDL_GetError()); 
   exit(1); 
 }
 
 svenbase.init("data/sven");
 sheepbase.init("data/sheep");
 
 sven.init(&svenbase,screen);
 sven.set(250,400);
 sven.setSpeed(0.8);

 sheep.init(&sheepbase,screen);
 sheep.set(350,300);
 sheep.setSpeed(3.5);
 
 sheep1.init(&sheepbase,screen);
 sheep1.set(150,250);
 sheep1.setSpeed(4.5);

 
 SDL_ShowCursor(0);
 
 InitImages();
 DrawBG();
 
 int done=0; 
 while(done == 0){ 
   
   SDL_Event event; 
   
   while ( SDL_PollEvent(&event) ){ 
     if ( event.type == SDL_QUIT ){ done = 1; } 
     if ( event.type == SDL_KEYDOWN ){
       if ( event.key.keysym.sym == SDLK_ESCAPE ){ done = 1; } 
       if ( event.key.keysym.sym == SDLK_SPACE ){ sven.toggleAnim(); }
     } 
   }
   
   keys = SDL_GetKeyState(NULL);
   if(keys[SDLK_UP]){ sven.yadd(-2); sven.xadd(2);}
   if(keys[SDLK_DOWN]){ sven.yadd(2); sven.xadd(-2); }
   if(keys[SDLK_LEFT]){ sven.xadd(-2); sven.yadd(-2); }
   if(keys[SDLK_RIGHT]){ sven.xadd(2); sven.yadd(2); }
   
   DrawScene();
 }
 
 return 0;
  
}

//-----------------------------------------
SDL_Surface* ImageLoad(char *file){
  
  SDL_Surface *temp1, *temp2;
  temp1 = SDL_LoadBMP(file);
  temp2 = SDL_DisplayFormat(temp1);
  SDL_FreeSurface(temp1);
  
  return temp2;

}

//-----------------------------------------
int InitImages(){

  back = ImageLoad("data/bg.bmp");
  return 0;

}

//-----------------------------------------
void DrawIMG(SDL_Surface *img, int x, int y){

 SDL_Rect dest;
 dest.x = x;
 dest.y = y;

 SDL_BlitSurface(img, NULL, screen, &dest);

}

//-----------------------------------------
void DrawBG(){

 DrawIMG(back, 0, 0);

}

//-----------------------------------------
void DrawScene(void){

  sven.clearBG();
  sheep.clearBG();
  sheep1.clearBG();
  
  sven.updateBG();
  sheep.updateBG();
  sheep1.updateBG();
    
  sven.draw();
  sheep.draw();
  sheep1.draw();  
  
  SDL_Flip(screen);
  
}

//-----------------------------------------
