// -------------------------------------------------------------
// Title:	CSprite2 library
// Version:	0.80
// Description:	2D SDL animated sprites made easy.
//		Supporting animated sprites from single BMP.
// Dependences:	SDL library
// File:	cspritebase2.h
// License:	GNU Library General Public License 2 (LGPL2)
// Authors:	Evgeny Bronnikov <bbroth@pochta.ru>
// -------------------------------------------------------------

#ifndef __CSPRITEBASE2_H__
#define __CSPRITEBASE2_H__

#include "SDL.h"

#define CSPRITE2_VER 2 // vertical animation frames alignment in source
#define CSPRITE2_HOR 4 // horizontal animation frames alignment in source


// inital structure
typedef struct
{
  char* bmpFile; //source image name
  int numFrames; //number of frames
  int pause;     //pause in milliseconds
  
  //RGB of transparent color
  int r;
  int g;	
  int b;
  
  int align;     //frames alignment in the source
} CSpriteInit2;


// internal structure, just don't use it.
typedef struct
{
  SDL_Surface* image;
} CSpriteFrame2;

class CSpriteBase2
{
  public:

// init base for sprites
  int init(CSpriteInit2* data);
  
// you don't need following stuff.
  CSpriteFrame2* mAnim;
  int mPause;
  int mNumFrames;
  int mW, mH;
};


#endif //__CSPRITEBASE2_H__
