// -------------------------------------------------------------
// Title:	Automatic using DGA extension in SDL programs
// Version:	0.80
// Description:	Tiny functions to allow DGA extension in your programs.
//		Supporting temporary setting up SDL_VIDEODRIVER environment
//		variable to "dga" and then restore it.
// Dependences:	No
// File:	dga_sdl.c
// License:	GNU Library General Public License 2 (LGPL2)
// Authors:	Evgeny Bronnikov <bbroth@pochta.ru>
// -------------------------------------------------------------

#include "dga_sdl.h"

char* old_env;

/* -------------------------------------------- */
void DGA_SetEnv(){
#ifdef USE_DGA
  old_env = getenv("SDL_VIDEODRIVER");
  printf("Warning: SDL_VIDEODRIVER: %s will be changed to dga!!!\n",old_env);  
  setenv("SDL_VIDEODRIVER", "dga", 1);
#endif
}

/* -------------------------------------------- */
void DGA_RestoreEnv(){
#ifdef USE_DGA
  setenv("SDL_VIDEODRIVER", old_env, 1);
#endif
}

/* -------------------------------------------- */
