// -------------------------------------------------------------
// Title:	Automatic using DGA extension in SDL programs
// Version:	0.80
// Description:	Tiny functions to allow DGA extension in your programs.
//		Supporting temporary setting up SDL_VIDEODRIVER environment
//		variable to "dga" and then restore it.
// Dependences:	No
// File:	dga_sdl.h
// License:	GNU Library General Public License 2 (LGPL2)
// Authors:	Evgeny Bronnikov <bbroth@pochta.ru>
// -------------------------------------------------------------


#ifndef _DGA_SDL_H_
#define _DGA_SDL_H_

#include <stdlib.h>

/* Define C function definitions if using C++ */
#ifdef __cplusplus
extern "C" {
#endif

/* 
 *         WARNING!!!
 * Just comment this definition
 *   to disable DGA driver
 *       using for SDL!
 */
 
//#define USE_DGA


/* Set environ variable SDL_VIDEODRIVER to "dga" for really fast blitting */
extern void DGA_SetEnv(void);

/* Restore SDL_VIDEODRIVER before exiting program */
extern void DGA_RestoreEnv(void);

#ifdef __cplusplus
}
#endif

#endif /* _DGA_SDL_H_ */
