#include <stdio.h>
#include <stdlib.h>

#include "svssprite.h"
#include "svsbase.h"

#include "SDL.h"


SDL_Surface* ImageLoad(char *file);
int InitImages();
void DrawIMG(SDL_Surface *img, int x, int y);
void DrawBG(void);
void DrawScene(void);

SDL_Surface *screen, *back;

svsBase svenbase;
svsSprite sven;

svsBase nf1base;
svsSprite nf1;

svsBase nf2base;
svsSprite nf2;

svsBase nf3base;
svsSprite nf3;

svsBase nf4base;
svsSprite nf4;


//-----------------------------------------
int main(int argc, char *argv[]){ 
 
 Uint8* keys;
 
 if ( SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO) < 0 ){ 
   printf("Unable to init SDL: %s\n", SDL_GetError()); 
   exit(1); 
 } 
 
 atexit(SDL_Quit); 

 SDL_WM_SetCaption("Sven Bomwollen","Svenix");
 SDL_WM_SetIcon(SDL_LoadBMP("data/icon.bmp"), NULL);
 
 screen=SDL_SetVideoMode(800,600,32,SDL_HWSURFACE|SDL_DOUBLEBUF); //|SDL_FULLSCREEN
 if ( screen == NULL ){ 
   printf("Unable to set 800x600 video: %s\n", SDL_GetError()); 
   exit(1); 
 }
 
 svsInit mInit;
 mInit.bmpFile = "data/nf19.bmp";
 mInit.numFrames = 7;
 mInit.pause = 90;
 mInit.r = 255;
 mInit.g = 0;
 mInit.b = 255;
 svenbase.init(&mInit);
 sven.init(&svenbase,screen);
 sven.set(250,400);
 sven.setSpeed(0.9);

 mInit.bmpFile = "data/nf08.bmp";
 mInit.numFrames = 8;
 nf1base.init(&mInit);
 nf1.init(&nf1base,screen);
 nf1.set(450,300);
 nf1.setSpeed(0.9);
 
 mInit.bmpFile = "data/shag10.bmp";
 mInit.numFrames = 7;
 nf2base.init(&mInit);
 nf2.init(&nf2base,screen);
 nf2.set(250,230);
 nf2.setSpeed(0.9);

 mInit.bmpFile = "data/nf16.bmp";
 mInit.numFrames = 8;
 nf3base.init(&mInit);
 nf3.init(&nf3base,screen);
 nf3.set(600,230);
 nf3.setSpeed(0.9);
 
 mInit.bmpFile = "data/shag04.bmp";
 mInit.numFrames = 7;
 nf4base.init(&mInit);
 nf4.init(&nf4base,screen);
 nf4.set(100,300);
 nf4.setSpeed(0.9);
 
 SDL_ShowCursor(0);
 
 InitImages();
 DrawBG();
 
 int done=0; 
 while(done == 0){ 
   
   SDL_Event event; 
   
   while ( SDL_PollEvent(&event) ){ 
     if ( event.type == SDL_QUIT ){ done = 1; } 
     if ( event.type == SDL_KEYDOWN ){
       if ( event.key.keysym.sym == SDLK_ESCAPE ){ done = 1; } 
       if ( event.key.keysym.sym == SDLK_SPACE ){ sven.toggleAnim(); }
     } 
   }
   
   keys = SDL_GetKeyState(NULL);
   if(keys[SDLK_UP]){ sven.yadd(-2); sven.xadd(2);}
   if(keys[SDLK_DOWN]){ sven.yadd(2); sven.xadd(-2); }
   if(keys[SDLK_LEFT]){ sven.xadd(-2); sven.yadd(-2); }
   if(keys[SDLK_RIGHT]){ sven.xadd(2); sven.yadd(2); }
   
   DrawScene();
 }
 
 return 0;
  
}

//-----------------------------------------
SDL_Surface* ImageLoad(char *file){
  
  SDL_Surface *temp1, *temp2;
  temp1 = SDL_LoadBMP(file);
  temp2 = SDL_DisplayFormat(temp1);
  SDL_FreeSurface(temp1);
  
  return temp2;

}

//-----------------------------------------
int InitImages(){

  back = ImageLoad("data/bg.bmp");
  return 0;

}

//-----------------------------------------
void DrawIMG(SDL_Surface *img, int x, int y){

 SDL_Rect dest;
 dest.x = x;
 dest.y = y;

 SDL_BlitSurface(img, NULL, screen, &dest);

}

//-----------------------------------------
void DrawBG(){

 DrawIMG(back, 0, 0);

}

//-----------------------------------------
void DrawScene(void){

  sven.clearBG();
  nf1.clearBG();
  nf2.clearBG();  
  nf3.clearBG();
  nf4.clearBG();  
  
  sven.updateBG();
  nf1.updateBG();
  nf2.updateBG();
  nf3.updateBG();
  nf4.updateBG();  
  
  sven.draw();
  nf1.draw();
  nf2.draw();
  nf3.draw();
  nf4.draw();  
  
  SDL_Flip(screen);
  
}

//-----------------------------------------
