#include <stdio.h>
#include <stdlib.h> 
#include "SDL.h"
#include "SDL_ttf.h"

void print_ttf(SDL_Surface *sDest, char* message, char* font, int size, SDL_Color color, SDL_Rect dest);

/* ------------------------------------------- */
int main(int argc, char *argv[]){ 
 
 if ( SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO) < 0 ){ 
   printf("Unable to init SDL: %s\n", SDL_GetError()); 
   exit(1); 
 } 
 
 atexit(SDL_Quit); 

 SDL_WM_SetCaption("SDL Gfx Example #1","ex1");
 SDL_WM_SetIcon(SDL_LoadBMP("icon.bmp"), NULL);
 
 SDL_Surface *screen; 
 screen=SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_DOUBLEBUF); 
 if ( screen == NULL ){ 
   printf("Unable to set 640x480 video: %s\n", SDL_GetError()); 
   exit(1); 
 } 
 
 TTF_Init();
 atexit(TTF_Quit);
 
 SDL_Color clr = {255,50,40,0};
 SDL_Rect dest = {80, 120,0,0};
 print_ttf(screen, "SDL_ttf example", "courier.ttf", 46, clr, dest);

 clr.r = 255;
 clr.g = 255;
 clr.b = 0;
 dest.x = 80;
 dest.y = 250;
 print_ttf(screen, " SDL_ttf", "courier.ttf", 46, clr, dest);
 
 SDL_Flip(screen);
 
 int done=0; 
 while(done == 0){ 
   
   SDL_Event event; 
   
   while ( SDL_PollEvent(&event) ){ 
     if ( event.type == SDL_QUIT ){ 
      done = 1; 
     } 
     if ( event.type == SDL_KEYDOWN ){
       if ( event.key.keysym.sym == SDLK_ESCAPE ){ 
         done = 1; 
       } 
     } 
   } 
  
 }
  
}


/* ------------------------------------------------------ */
void print_ttf(SDL_Surface *sDest, char* message, char* font, int size, SDL_Color color, SDL_Rect dest){

 TTF_Font *fnt = TTF_OpenFont(font, size);
 SDL_Surface *sText = TTF_RenderText_Blended( fnt, message, color);
 SDL_BlitSurface( sText,NULL, sDest,&dest );
 SDL_FreeSurface( sText );
 TTF_CloseFont( fnt );

}

